package com.dbnt.faisp.controller;

import com.dbnt.faisp.userInfo.model.UserInfo;
import com.dbnt.faisp.codeMgt.CodeMgtService;
import lombok.RequiredArgsConstructor;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpSession;

@RestController
@RequiredArgsConstructor
public class BaseController {

  private final CodeMgtService codeMgtService;

  @GetMapping("/")
  public ModelAndView loginCheck(@AuthenticationPrincipal UserInfo loginUser, HttpSession session) {
    ModelAndView mav = null;
    if(loginUser == null){
      mav = new ModelAndView("redirect:/login");
    }else{
      session.setAttribute("commonCodeList", codeMgtService.selectCommonCodeList());
      mav = new ModelAndView("redirect:/dashboard");
    }
    return mav;
  }

  @GetMapping("/refreshSession")
  public void getSession(HttpSession session){
    session.setAttribute("commonCodeList", codeMgtService.selectCommonCodeList());
  }

  @GetMapping("/login")
  public ModelAndView goLogin() {
    ModelAndView mav = new ModelAndView("/login/login");
    return mav;
  }

  @GetMapping("/login-error")
  public ModelAndView loginError() {
    ModelAndView mav = new ModelAndView("/login/login");
    mav.addObject("loginError", true);
    return mav;
  }

  @GetMapping("/denied")
  public ModelAndView doDenied() {
    ModelAndView mav = new ModelAndView("login/denied");
    return mav;
  }

  @GetMapping("/dashboard")
  public ModelAndView dashboard() {
    ModelAndView mav = new ModelAndView("login/dashboard");
    return mav;
  }
}
